
try:
    import coloramaDISABLED as colors
except ImportError:
    class stubColors:
        "subs for colors when colors doesn't exist on system"
    
        def __init__(self):
            self.Fore = colorClass()
            self.Back = colorClass()
            self.Style = styleClass()
    
    class colorClass():
        "stubbed color class"
    
        def __init__(self):
            self.BLACK = ""
            self.BLUE = ""
            self.WHITE = ""
            self.RED = ""
            self.GREEN = ""
    
    class styleClass():
        "stubbed style class"
    
        def __init__(self):
            self.RESET_ALL = ""
    colors = stubColors()

import sys
from .charonLineParserMaterialName import *
from .charonLineParserNitrideEfectiveDOS import *
from .charonLineParserBandgap import *
from .charonLineParserNitrideBandgap import *
from .charonLineParserReadIonDensity import *
from .charonLineParserSaveInitPotentialGrad import *
from .charonLineParserRadiativeRecombinationCoefficient import *
from .charonLineParserIntrinsicConcentration import *
from .charonLineParserAffinity import *
from .charonLineParserMMSDoping import *
from .charonLineParserReferenceMaterial import *
from .charonLineParserNitridePermittivity import *
from .charonLineParserDopingFile import *
from .charonLineParserRelativePermittivity import *
from .charonLineParserFixedMobility import *
from .charonBlockParserHeatCapacity import *
from .charonBlockParserEffectiveDOS import *
from .charonBlockParserIncompleteIonizationAcceptor import *
from .charonBlockParserTID import *
from .charonBlockParserTempDepIonSoretCoeff import *
from .charonBlockParserLinearDoping import *
from .charonBlockParserIonDepDiffCoeff import *
from .charonBlockParserBandGap import *
from .charonBlockParserBulkFixedChargeParameters import *
from .charonBlockParserDynamicTraps import *
from .charonBlockParserLucentMobility import *
from .charonBlockParserErfcDoping import *
from .charonBlockParserMGaussDoping import *
from .charonBlockParserGlobalMMSParameters import *
from .charonBlockParserPhilipsThomasMobility import *
from .charonBlockParserIntrinsicConc import *
from .charonBlockParserPhilipsMobility import *
from .charonBlockParserAroraMobility import *
from .charonBlockParserUniformDoping import *
from .charonBlockParserHaloMoleFraction import *
from .charonBlockParserDoping import *
from .charonBlockParserThermalConductivity import *
from .charonBlockParserUniformMoleFraction import *
from .charonBlockParserParticleStrikeParameters import *
from .charonBlockParserMOSFETMobility import *
from .charonBlockParserTrapSRH import *
from .charonBlockParserCarrierLifetime import *
from .charonBlockParserGlobalNorm import *
from .charonBlockParserGaussDoping import *
from .charonBlockParserGaAsMobility import *
from .charonBlockParserBand2BandTunneling import *
from .charonBlockParserMGaussMoleFraction import *
from .charonBlockParserMasettiMobility import *
from .charonBlockParserIncompleteIonizationDonor import *
from .charonBlockParserHaloDoping import *
from .charonBlockParserFarahmandMobility import *
from .charonBlockParserHeatGeneration import *
from .charonBlockParserRigidPointIonMobility import *
from .charonBlockParserOpticalGeneration import *
from .charonBlockParserGaussMoleFraction import *
from .charonBlockParserDopingFile1D import *
from .charonBlockParserRelPermittivity import *
from .charonBlockParserAvalancheGeneration import *
from .charonBlockParserErfcMoleFraction import *
from .charonBlockParserAugerRecombinationParameters import *
from .charonBlockParserAlbrechtMobility import *
from .charonBlockParserLinearMoleFraction import *
from .charonBlockParserStepDoping import *
from .HeatCapacity.HeatCapacityParserLib import *
from .EffectiveDOS.EffectiveDOSParserLib import *
from .IncompleteIonizationAcceptor.IncompleteIonizationAcceptorParserLib import *
from .TID.TIDParserLib import *
from .TempDepIonSoretCoeff.TempDepIonSoretCoeffParserLib import *
from .LinearDoping.LinearDopingParserLib import *
from .IonDepDiffCoeff.IonDepDiffCoeffParserLib import *
from .BandGap.BandGapParserLib import *
from .BulkFixedChargeParameters.BulkFixedChargeParametersParserLib import *
from .DynamicTraps.DynamicTrapsParserLib import *
from .LucentMobility.LucentMobilityParserLib import *
from .ErfcDoping.ErfcDopingParserLib import *
from .MGaussDoping.MGaussDopingParserLib import *
from .GlobalMMSParameters.GlobalMMSParametersParserLib import *
from .PhilipsThomasMobility.PhilipsThomasMobilityParserLib import *
from .IntrinsicConc.IntrinsicConcParserLib import *
from .PhilipsMobility.PhilipsMobilityParserLib import *
from .AroraMobility.AroraMobilityParserLib import *
from .UniformDoping.UniformDopingParserLib import *
from .HaloMoleFraction.HaloMoleFractionParserLib import *
from .Doping.DopingParserLib import *
from .ThermalConductivity.ThermalConductivityParserLib import *
from .UniformMoleFraction.UniformMoleFractionParserLib import *
from .ParticleStrikeParameters.ParticleStrikeParametersParserLib import *
from .MOSFETMobility.MOSFETMobilityParserLib import *
from .TrapSRH.TrapSRHParserLib import *
from .CarrierLifetime.CarrierLifetimeParserLib import *
from .GlobalNorm.GlobalNormParserLib import *
from .GaussDoping.GaussDopingParserLib import *
from .GaAsMobility.GaAsMobilityParserLib import *
from .Band2BandTunneling.Band2BandTunnelingParserLib import *
from .MGaussMoleFraction.MGaussMoleFractionParserLib import *
from .MasettiMobility.MasettiMobilityParserLib import *
from .IncompleteIonizationDonor.IncompleteIonizationDonorParserLib import *
from .HaloDoping.HaloDopingParserLib import *
from .FarahmandMobility.FarahmandMobilityParserLib import *
from .HeatGeneration.HeatGenerationParserLib import *
from .RigidPointIonMobility.RigidPointIonMobilityParserLib import *
from .OpticalGeneration.OpticalGenerationParserLib import *
from .GaussMoleFraction.GaussMoleFractionParserLib import *
from .DopingFile1D.DopingFile1DParserLib import *
from .RelPermittivity.RelPermittivityParserLib import *
from .AvalancheGeneration.AvalancheGenerationParserLib import *
from .ErfcMoleFraction.ErfcMoleFractionParserLib import *
from .AugerRecombinationParameters.AugerRecombinationParametersParserLib import *
from .AlbrechtMobility.AlbrechtMobilityParserLib import *
from .LinearMoleFraction.LinearMoleFractionParserLib import *
from .StepDoping.StepDopingParserLib import *



class MaterialBlockParserLib:
    "This is the  MaterialBlockParserLib parser library "


    def __init__(self):
        # set the parser library name 
        self.parserLibName = "MaterialBlockParserLib"
        # create the linparser objects 
        self.lineParsers = []
        self.lineParsers.append(charonLineParserMaterialName())
        self.lineParsers.append(charonLineParserNitrideEfectiveDOS())
        self.lineParsers.append(charonLineParserBandgap())
        self.lineParsers.append(charonLineParserNitrideBandgap())
        self.lineParsers.append(charonLineParserReadIonDensity())
        self.lineParsers.append(charonLineParserSaveInitPotentialGrad())
        self.lineParsers.append(charonLineParserRadiativeRecombinationCoefficient())
        self.lineParsers.append(charonLineParserIntrinsicConcentration())
        self.lineParsers.append(charonLineParserAffinity())
        self.lineParsers.append(charonLineParserMMSDoping())
        self.lineParsers.append(charonLineParserReferenceMaterial())
        self.lineParsers.append(charonLineParserNitridePermittivity())
        self.lineParsers.append(charonLineParserDopingFile())
        self.lineParsers.append(charonLineParserRelativePermittivity())
        self.lineParsers.append(charonLineParserFixedMobility())
        # create the blockparser objects 
        self.blockParsers = []
        self.blockParsers.append([charonBlockParserHeatCapacity(),HeatCapacityParserLib()])
        self.blockParsers.append([charonBlockParserEffectiveDOS(),EffectiveDOSParserLib()])
        self.blockParsers.append([charonBlockParserIncompleteIonizationAcceptor(),IncompleteIonizationAcceptorParserLib()])
        self.blockParsers.append([charonBlockParserTID(),TIDParserLib()])
        self.blockParsers.append([charonBlockParserTempDepIonSoretCoeff(),TempDepIonSoretCoeffParserLib()])
        self.blockParsers.append([charonBlockParserLinearDoping(),LinearDopingParserLib()])
        self.blockParsers.append([charonBlockParserIonDepDiffCoeff(),IonDepDiffCoeffParserLib()])
        self.blockParsers.append([charonBlockParserBandGap(),BandGapParserLib()])
        self.blockParsers.append([charonBlockParserBulkFixedChargeParameters(),BulkFixedChargeParametersParserLib()])
        self.blockParsers.append([charonBlockParserDynamicTraps(),DynamicTrapsParserLib()])
        self.blockParsers.append([charonBlockParserLucentMobility(),LucentMobilityParserLib()])
        self.blockParsers.append([charonBlockParserErfcDoping(),ErfcDopingParserLib()])
        self.blockParsers.append([charonBlockParserMGaussDoping(),MGaussDopingParserLib()])
        self.blockParsers.append([charonBlockParserGlobalMMSParameters(),GlobalMMSParametersParserLib()])
        self.blockParsers.append([charonBlockParserPhilipsThomasMobility(),PhilipsThomasMobilityParserLib()])
        self.blockParsers.append([charonBlockParserIntrinsicConc(),IntrinsicConcParserLib()])
        self.blockParsers.append([charonBlockParserPhilipsMobility(),PhilipsMobilityParserLib()])
        self.blockParsers.append([charonBlockParserAroraMobility(),AroraMobilityParserLib()])
        self.blockParsers.append([charonBlockParserUniformDoping(),UniformDopingParserLib()])
        self.blockParsers.append([charonBlockParserHaloMoleFraction(),HaloMoleFractionParserLib()])
        self.blockParsers.append([charonBlockParserDoping(),DopingParserLib()])
        self.blockParsers.append([charonBlockParserThermalConductivity(),ThermalConductivityParserLib()])
        self.blockParsers.append([charonBlockParserUniformMoleFraction(),UniformMoleFractionParserLib()])
        self.blockParsers.append([charonBlockParserParticleStrikeParameters(),ParticleStrikeParametersParserLib()])
        self.blockParsers.append([charonBlockParserMOSFETMobility(),MOSFETMobilityParserLib()])
        self.blockParsers.append([charonBlockParserTrapSRH(),TrapSRHParserLib()])
        self.blockParsers.append([charonBlockParserCarrierLifetime(),CarrierLifetimeParserLib()])
        self.blockParsers.append([charonBlockParserGlobalNorm(),GlobalNormParserLib()])
        self.blockParsers.append([charonBlockParserGaussDoping(),GaussDopingParserLib()])
        self.blockParsers.append([charonBlockParserGaAsMobility(),GaAsMobilityParserLib()])
        self.blockParsers.append([charonBlockParserBand2BandTunneling(),Band2BandTunnelingParserLib()])
        self.blockParsers.append([charonBlockParserMGaussMoleFraction(),MGaussMoleFractionParserLib()])
        self.blockParsers.append([charonBlockParserMasettiMobility(),MasettiMobilityParserLib()])
        self.blockParsers.append([charonBlockParserIncompleteIonizationDonor(),IncompleteIonizationDonorParserLib()])
        self.blockParsers.append([charonBlockParserHaloDoping(),HaloDopingParserLib()])
        self.blockParsers.append([charonBlockParserFarahmandMobility(),FarahmandMobilityParserLib()])
        self.blockParsers.append([charonBlockParserHeatGeneration(),HeatGenerationParserLib()])
        self.blockParsers.append([charonBlockParserRigidPointIonMobility(),RigidPointIonMobilityParserLib()])
        self.blockParsers.append([charonBlockParserOpticalGeneration(),OpticalGenerationParserLib()])
        self.blockParsers.append([charonBlockParserGaussMoleFraction(),GaussMoleFractionParserLib()])
        self.blockParsers.append([charonBlockParserDopingFile1D(),DopingFile1DParserLib()])
        self.blockParsers.append([charonBlockParserRelPermittivity(),RelPermittivityParserLib()])
        self.blockParsers.append([charonBlockParserAvalancheGeneration(),AvalancheGenerationParserLib()])
        self.blockParsers.append([charonBlockParserErfcMoleFraction(),ErfcMoleFractionParserLib()])
        self.blockParsers.append([charonBlockParserAugerRecombinationParameters(),AugerRecombinationParametersParserLib()])
        self.blockParsers.append([charonBlockParserAlbrechtMobility(),AlbrechtMobilityParserLib()])
        self.blockParsers.append([charonBlockParserLinearMoleFraction(),LinearMoleFractionParserLib()])
        self.blockParsers.append([charonBlockParserStepDoping(),StepDopingParserLib()])
        # create the parserLibrary objects 
        parserLibraries = []
        parserLibraries.append(HeatCapacityParserLib())
        parserLibraries.append(EffectiveDOSParserLib())
        parserLibraries.append(IncompleteIonizationAcceptorParserLib())
        parserLibraries.append(TIDParserLib())
        parserLibraries.append(TempDepIonSoretCoeffParserLib())
        parserLibraries.append(LinearDopingParserLib())
        parserLibraries.append(IonDepDiffCoeffParserLib())
        parserLibraries.append(BandGapParserLib())
        parserLibraries.append(BulkFixedChargeParametersParserLib())
        parserLibraries.append(DynamicTrapsParserLib())
        parserLibraries.append(LucentMobilityParserLib())
        parserLibraries.append(ErfcDopingParserLib())
        parserLibraries.append(MGaussDopingParserLib())
        parserLibraries.append(GlobalMMSParametersParserLib())
        parserLibraries.append(PhilipsThomasMobilityParserLib())
        parserLibraries.append(IntrinsicConcParserLib())
        parserLibraries.append(PhilipsMobilityParserLib())
        parserLibraries.append(AroraMobilityParserLib())
        parserLibraries.append(UniformDopingParserLib())
        parserLibraries.append(HaloMoleFractionParserLib())
        parserLibraries.append(DopingParserLib())
        parserLibraries.append(ThermalConductivityParserLib())
        parserLibraries.append(UniformMoleFractionParserLib())
        parserLibraries.append(ParticleStrikeParametersParserLib())
        parserLibraries.append(MOSFETMobilityParserLib())
        parserLibraries.append(TrapSRHParserLib())
        parserLibraries.append(CarrierLifetimeParserLib())
        parserLibraries.append(GlobalNormParserLib())
        parserLibraries.append(GaussDopingParserLib())
        parserLibraries.append(GaAsMobilityParserLib())
        parserLibraries.append(Band2BandTunnelingParserLib())
        parserLibraries.append(MGaussMoleFractionParserLib())
        parserLibraries.append(MasettiMobilityParserLib())
        parserLibraries.append(IncompleteIonizationDonorParserLib())
        parserLibraries.append(HaloDopingParserLib())
        parserLibraries.append(FarahmandMobilityParserLib())
        parserLibraries.append(HeatGenerationParserLib())
        parserLibraries.append(RigidPointIonMobilityParserLib())
        parserLibraries.append(OpticalGenerationParserLib())
        parserLibraries.append(GaussMoleFractionParserLib())
        parserLibraries.append(DopingFile1DParserLib())
        parserLibraries.append(RelPermittivityParserLib())
        parserLibraries.append(AvalancheGenerationParserLib())
        parserLibraries.append(ErfcMoleFractionParserLib())
        parserLibraries.append(AugerRecombinationParametersParserLib())
        parserLibraries.append(AlbrechtMobilityParserLib())
        parserLibraries.append(LinearMoleFractionParserLib())
        parserLibraries.append(StepDopingParserLib())


    def isThisMyLine(self,tokenizer,line):
        suggestedSyntax = []
        for lP in self.lineParsers:
            (self.isThisMe,suggestedSyntaxItem) = lP.isThisMe(tokenizer,line)
            if suggestedSyntaxItem is not "":
                suggestedSyntax.append(suggestedSyntaxItem)
            if self.isThisMe == True:
                return (True,lP,suggestedSyntax)
        return (False,None,suggestedSyntax)


    def isThisMyBlock(self,tokenizer,line):
        for bP in self.blockParsers:
            self.isThisMe = bP[0].isThisMe(tokenizer,line)
            if self.isThisMe == True:
                return (True,bP[0],bP[1])
        return (False,None,None)


    def generateHelp(self,genHelp,indent):
        self.addIndent = "     "
        cRStyle = ""
        for lP in self.lineParsers:
            (self.helpLine,self.helpContent) = lP.getHelp(genHelp)
            self.helpContentList = self.helpContent.split("<>")
            print (cRStyle+indent+colors.Fore.RED+colors.Back.WHITE+self.helpLine)
            cRStyle = "\n"
            for hCL in self.helpContentList:
                print ("\t"+indent+colors.Fore.BLUE+colors.Back.WHITE+hCL.lstrip())
        for bP in range(len(self.blockParsers)):
            print (indent+colors.Fore.GREEN+colors.Back.WHITE+self.blockParsers[bP][0].getHelpLine().lstrip())
            self.blockParsers[bP][1].generateHelp(genHelp,indent+self.addIndent)
            print (indent+colors.Fore.GREEN+colors.Back.WHITE+self.blockParsers[bP][0].getHelpLine().replace("start","end").lstrip())
            print (indent+colors.Style.RESET_ALL)


    def getName(self):
        return self.parserLibName
