
import copy


class charonLineParserVerbosityLevel:
    "VerbosityLevel parser"

    def __init__(self):
        # Register the parsing keys
        self.parserName = "VerbosityLevel"
        self.primary = "verbosity level is"
        self.options = []
        self.options.append("low")
        self.options.append("medium")
        self.options.append("high")
        self.options.append("extreme")
        self.foundOptions = []
        for index,opt in enumerate(self.options):
            self.foundOptions.append(False)
        self.primaryVariables = []
        self.optionVariables = [[]]*len(self.options)
        self.interpreterHelpLine = "verbosity level is [ low [ medium [ high [ extreme ]]]] "
        self.interpreterQuickHelp = "How much output to produce to show the progress of the solvers."
        self.interpreterLongHelp = "How much output to produce to show the progress of the solvers."

        # Register the xml required lines
        self.xmlRequiredLines = []
        self.xmlRequiredLinePriority = []
        self.xmlNewRequiredLines = []

        # Register the xml optional lines
        self.xmlOptionalLines = [[]]
        self.xmlOptionalLinePriority = [[]]
        self.xmlOptionalLines[0].append(" Charon->Solution Control->NOX->Direction->Newton->Stratimikos Linear Solver->Stratimikos->Linear Solver Types->Belos->VerboseObject,Verbosity Level,string,low")
        self.xmlOptionalLines[0].append(" Charon->Solution Control->NOX->Printing->Output Information,Error,bool,false")
        self.xmlOptionalLines[0].append(" Charon->Solution Control->NOX->Printing->Output Information,Warning,bool,false")
        self.xmlOptionalLines[0].append(" Charon->Solution Control->NOX->Printing->Output Information,Inner Iteration,bool,false")
        self.xmlOptionalLines[0].append(" Charon->Solution Control->NOX->Printing->Output Information,Outer Iteration,bool,false")
        self.xmlOptionalLines[0].append(" Charon->Solution Control->NOX->Printing->Output Information,Outer Iteration StatusTest,bool,false")
        self.xmlOptionalLines[0].append(" Charon->Solution Control->NOX->Printing->Output Information,Parameters,bool,false")
        self.xmlOptionalLines[0].append(" Charon->Solution Control->NOX->Printing->Output Information,Details,bool,false")
        self.xmlOptionalLines[0].append(" Charon->Solution Control->NOX->Printing->Output Information,Linear Solver Details,bool,false")
        self.xmlOptionalLines[0].append(" Charon->Solution Control->NOX->Printing->Output Information,Stepper Iteration,bool,false")
        self.xmlOptionalLines[0].append(" Charon->Solution Control->NOX->Printing->Output Information,Stepper Details,bool,false")
        self.xmlOptionalLines[0].append(" Charon->Solution Control->NOX->Printing->Output Information,Stepper Parameters,bool,false")
        self.xmlOptionalLines.append([])
        self.xmlOptionalLines[1].append(" Charon->Solution Control->NOX->Direction->Newton->Stratimikos Linear Solver->Stratimikos->Linear Solver Types->Belos->VerboseObject,Verbosity Level,string,medium")
        self.xmlOptionalLines[1].append(" Charon->Solution Control->NOX->Printing->Output Information,Error,bool,false")
        self.xmlOptionalLines[1].append(" Charon->Solution Control->NOX->Printing->Output Information,Warning,bool,false")
        self.xmlOptionalLines[1].append(" Charon->Solution Control->NOX->Printing->Output Information,Inner Iteration,bool,false")
        self.xmlOptionalLines[1].append(" Charon->Solution Control->NOX->Printing->Output Information,Outer Iteration,bool,true")
        self.xmlOptionalLines[1].append(" Charon->Solution Control->NOX->Printing->Output Information,Outer Iteration StatusTest,bool,false")
        self.xmlOptionalLines[1].append(" Charon->Solution Control->NOX->Printing->Output Information,Parameters,bool,false")
        self.xmlOptionalLines[1].append(" Charon->Solution Control->NOX->Printing->Output Information,Details,bool,false")
        self.xmlOptionalLines[1].append(" Charon->Solution Control->NOX->Printing->Output Information,Linear Solver Details,bool,false")
        self.xmlOptionalLines[1].append(" Charon->Solution Control->NOX->Printing->Output Information,Stepper Iteration,bool,false")
        self.xmlOptionalLines[1].append(" Charon->Solution Control->NOX->Printing->Output Information,Stepper Details,bool,false")
        self.xmlOptionalLines[1].append(" Charon->Solution Control->NOX->Printing->Output Information,Stepper Parameters,bool,false")
        self.xmlOptionalLines.append([])
        self.xmlOptionalLines[2].append(" Charon->Solution Control->NOX->Direction->Newton->Stratimikos Linear Solver->Stratimikos->Linear Solver Types->Belos->VerboseObject,Verbosity Level,string,high")
        self.xmlOptionalLines.append([])
        self.xmlOptionalLines[3].append(" Charon->Solution Control->NOX->Direction->Newton->Stratimikos Linear Solver->Stratimikos->Linear Solver Types->Belos->VerboseObject,Verbosity Level,string,extreme")
        self.xmlOptionalLinePriority[0].append(2)
        self.xmlOptionalLinePriority[0].append(2)
        self.xmlOptionalLinePriority[0].append(2)
        self.xmlOptionalLinePriority[0].append(2)
        self.xmlOptionalLinePriority[0].append(2)
        self.xmlOptionalLinePriority[0].append(2)
        self.xmlOptionalLinePriority[0].append(2)
        self.xmlOptionalLinePriority[0].append(2)
        self.xmlOptionalLinePriority[0].append(2)
        self.xmlOptionalLinePriority[0].append(2)
        self.xmlOptionalLinePriority[0].append(2)
        self.xmlOptionalLinePriority[0].append(2)
        self.xmlOptionalLinePriority.append([])
        self.xmlOptionalLinePriority[1].append(2)
        self.xmlOptionalLinePriority[1].append(2)
        self.xmlOptionalLinePriority[1].append(2)
        self.xmlOptionalLinePriority[1].append(2)
        self.xmlOptionalLinePriority[1].append(2)
        self.xmlOptionalLinePriority[1].append(2)
        self.xmlOptionalLinePriority[1].append(2)
        self.xmlOptionalLinePriority[1].append(2)
        self.xmlOptionalLinePriority[1].append(2)
        self.xmlOptionalLinePriority[1].append(2)
        self.xmlOptionalLinePriority[1].append(2)
        self.xmlOptionalLinePriority[1].append(2)
        self.xmlOptionalLinePriority.append([])
        self.xmlOptionalLinePriority[2].append(2)
        self.xmlOptionalLinePriority.append([])
        self.xmlOptionalLinePriority[3].append(2)

        # Register the xml default lines
        self.xmlDefaultLines = []
        self.xmlDefaultLinePriority = []

        self.xmlReturned = []
        self.xmlPriorityCode = []
        self.specialInformation = []



    def isThisMe(self,tokenizer,line):
        affirmPrimary = False
        for index,fO in enumerate(self.foundOptions):
            self.foundOptions[index] = False
        self.primaryVariables = {}
        self.optionVariables = []*len(self.options)
        (affirmPrimary,self.foundOptions,self.primaryVariables,self.optionVariables,suggestedSyntax) = tokenizer.isItMe(line,self.primary,self.options)
        return (affirmPrimary,suggestedSyntax)



    def getName(self):
        # Return parser name
         return self.parserName



    def getHelp(self,verbosity):
        # Return help content
        if verbosity.lower() == "long":
            return (self.interpreterHelpLine,self.interpreterLongHelp)
        else:
            return (self.interpreterHelpLine,self.interpreterQuickHelp)



    def generateXML(self,tokenizer,line):
        # Tokenize the line
        lineTokens = tokenizer.tokenize(line)
        self.xmlNewRequiredLines[:] = []
        for xL in self.xmlRequiredLines:
            self.xmlNewRequiredLines.append(xL)

        for key in self.primaryVariables:
            for nRLIndex,nRL in enumerate(self.xmlNewRequiredLines):
                self.xmlNewRequiredLines[nRLIndex] = nRL.replace(key,self.primaryVariables[key])
            for siIndex, siValue in enumerate(self.specialInformation):
                self.specialInformation[siIndex] = [item.replace(key,self.primaryVariables[key]) for item in siValue]

        for index,xmlLine in enumerate(self.xmlNewRequiredLines):
            self.xmlReturned.append(xmlLine)
            self.xmlPriorityCode.append(self.xmlRequiredLinePriority[index]) #required lines have priority code 2
        for optIndex,fO in enumerate(self.foundOptions):
            if fO == True:
                self.Returned=copy.deepcopy(self.xmlOptionalLines[optIndex])
                for key in self.primaryVariables:
                    for retIndex,xOL in enumerate(self.Returned):
                        self.Returned[retIndex] = xOL.replace(key,self.primaryVariables[key])
                for key in self.optionVariables[optIndex]:
                    for retIndex,xOL in enumerate(self.Returned):
                        self.Returned[retIndex] = xOL.replace(key,self.optionVariables[optIndex][key])
                        for siIndex, siValue in enumerate(self.specialInformation):
                            self.specialInformation[siIndex] = [item.replace(key,self.optionVariables[optIndex][key]) for item in siValue]
                for retIndex,ret in enumerate(self.Returned):
                    self.xmlReturned.append(ret)
                    self.xmlPriorityCode.append(self.xmlOptionalLinePriority[optIndex][retIndex])

        for xmlLine in self.xmlDefaultLines:
            self.xmlReturned.append(xmlLine)
            self.xmlPriorityCode.append(1) #optional lines have priority code 1

        return (self.xmlReturned,self.xmlPriorityCode,self.specialInformation)



